"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var StringUtils_1=require("../utils/StringUtils"),ArrayUtils_1=require("../utils/ArrayUtils"),FilesManager=function(){function t(t,i,r,e,s){this.fs=t,this.os=i,this.path=r,this.process=e,this.crypto=s,this._tempDirectoriesToDelete=[]}return t.prototype.dirSep=function(){return this.path.sep},t.prototype.isFile=function(t){if(!StringUtils_1.StringUtils.isString(t))throw new Error("path must be a string");try{return this.fs.lstatSync(t).isFile()}catch(t){return!1}},t.prototype.isFileEqualTo=function(t,i){if(!this.isFile(t))throw new Error("Not a file: "+t);if(!this.isFile(i))throw new Error("Not a file: "+i);var r=this.crypto.createHash("md5").update(this.readFile(t),"utf8").digest("hex"),e=this.crypto.createHash("md5").update(this.readFile(i),"utf8").digest("hex");return this.getFileSize(t)===this.getFileSize(i)&&r===e},t.prototype.isDirectory=function(t){if(!StringUtils_1.StringUtils.isString(t))throw new Error("path must be a string");try{return this.fs.lstatSync(this.fs.realpathSync(t)).isDirectory()}catch(t){return!1}},t.prototype.isDirectoryEqualTo=function(t,i){t=StringUtils_1.StringUtils.formatPath(t,this.dirSep()),i=StringUtils_1.StringUtils.formatPath(i,this.dirSep());var r=this.getDirectoryList(t,"nameAsc"),e=this.getDirectoryList(i,"nameAsc");if(!ArrayUtils_1.ArrayUtils.isEqualTo(r,e))return!1;for(var s=0;s<r.length;s++){var o=t+this.dirSep()+r[s],n=i+this.dirSep()+e[s],h=this.isDirectory(o);if(h&&!this.isDirectoryEqualTo(o,n))return!1;if(!h&&!this.isFileEqualTo(o,n))return!1}return!0},t.prototype.isDirectoryEmpty=function(t){return this.getDirectoryList(t).length<=0},t.prototype.findDirectoryItems=function(t,i,r,e,s){void 0===r&&(r="relative"),void 0===e&&(e="both"),void 0===s&&(s=-1);var o=[];t=StringUtils_1.StringUtils.formatPath(t,this.dirSep());for(var n=0,h=this.getDirectoryList(t);n<h.length;n++){var c=h[n],a=t+this.dirSep()+c,l=this.isDirectory(a),p=this.isFile(a);"folders"===e&&p||(new RegExp(i).test(c)&&("files"===e&&l||o.push(a)),0!==s&&l&&(o=o.concat(this.findDirectoryItems(a,i,"absolute",e,s-1))))}if("absolute"!==r)for(var u=0;u<o.length;u++)o[u]="name"===r?StringUtils_1.StringUtils.getPathElement(o[u]):StringUtils_1.StringUtils.replace(o[u],t+this.dirSep(),"");return o},t.prototype.findUniqueDirectoryName=function(t,i,r,e,s){if(void 0===i&&(i=""),void 0===r&&(r=""),void 0===e&&(e="-"),void 0===s&&(s=!1),t=StringUtils_1.StringUtils.formatPath(t,this.dirSep()),!this.isDirectory(t))throw new Error("path does not exist: "+t);for(var o=1,n=""==i?o:i;this.isDirectory(t+this.dirSep()+n)||this.isFile(t+this.dirSep()+n);)n=this._generateUniqueNameAux(o,i,r,e,s),o++;return n},t.prototype.findUniqueFileName=function(t,i,r,e,s){if(void 0===i&&(i=""),void 0===r&&(r=""),void 0===e&&(e="-"),void 0===s&&(s=!1),t=StringUtils_1.StringUtils.formatPath(t,this.dirSep()),!this.isDirectory(t))throw new Error("path does not exist: "+t);for(var o=1,n=""==i?o:i,h=StringUtils_1.StringUtils.getPathExtension(i);this.isDirectory(t+this.dirSep()+n)||this.isFile(t+this.dirSep()+n);)n=this._generateUniqueNameAux(o,StringUtils_1.StringUtils.getPathElementWithoutExt(i),r,e,s),""!=h&&(n+="."+h),o++;return n},t.prototype.createDirectory=function(t,i){if(void 0===i&&(i=!1),this.isDirectory(t))return!1;if(this.isFile(t))throw new Error("specified path is an existing file "+t);try{if(i)for(var r="",e=0;e<StringUtils_1.StringUtils.countPathElements(t);e++)r+=StringUtils_1.StringUtils.getPathElement(t,e)+this.dirSep(),this.isDirectory(r)||this.fs.mkdirSync(r);else this.fs.mkdirSync(t)}catch(i){if(!this.isDirectory(t))throw i;return!1}return!0},t.prototype.createTempDirectory=function(t,i){var r=this;void 0===i&&(i=!0);var e=StringUtils_1.StringUtils.formatPath(this.os.tmpdir(),this.dirSep()),s=e+this.dirSep()+this.findUniqueDirectoryName(e,t);if(!this.createDirectory(s))throw new Error("Could not create TMP directory "+s);return i&&(this._tempDirectoriesToDelete.push(s),this._tempDirectoriesToDelete.length<2&&this.process.once("exit",function(){for(var t=0,i=r._tempDirectoriesToDelete;t<i.length;t++){var e=i[t];r.isDirectory(e)&&r.deleteDirectory(e)}})),s},t.prototype.getDirectoryList=function(t,i){if(void 0===i&&(i=""),!this.isDirectory(t))throw new Error("path does not exist: "+t);for(var r=[],e=0,s=this.fs.readdirSync(t);e<s.length;e++){var o=s[e];if("."!==o&&".."!==o)switch(i){case"mDateAsc":case"mDateDesc":break;default:r.push(o)}}switch(i){case"nameAsc":r.sort();break;case"nameDesc":r.sort(),r.reverse();break;case"mDateAsc":case"mDateDesc":break;default:if(""!==i)throw new Error("Unknown sort method")}return r},t.prototype.getDirectorySize=function(t){for(var i=0,r=0,e=this.getDirectoryList(t);r<e.length;r++){var s=e[r],o=t+this.dirSep()+s;i+=this.isDirectory(o)?this.getDirectorySize(o):this.getFileSize(o)}return i},t.prototype.copyDirectory=function(t,i,r){if(void 0===r&&(r=!0),(t=StringUtils_1.StringUtils.formatPath(t,this.dirSep()))===(i=StringUtils_1.StringUtils.formatPath(i,this.dirSep())))throw new Error("cannot copy a directory into itself: "+t);if(r&&!this.isDirectoryEmpty(i))throw new Error("destPath must be empty");for(var e=0,s=this.getDirectoryList(t);e<s.length;e++){var o=s[e],n=t+this.dirSep()+o,h=i+this.dirSep()+o;if(this.isDirectory(n)){if(!this.isDirectory(h)&&!this.createDirectory(h))return!1;if(!this.copyDirectory(n,h,r))return!1}else if(!this.copyFile(n,h))return!1}return!0},t.prototype.syncDirectories=function(){},t.prototype.renameDirectory=function(t,i){if(!this.isDirectory(t)||this.isDirectory(i)||this.isFile(i))return!1;try{return this.fs.renameSync(t,i),!0}catch(t){return!1}},t.prototype.deleteDirectory=function(t,i){if(void 0===i&&(i=!0),t=StringUtils_1.StringUtils.formatPath(t,this.dirSep()),!this.isDirectory(t))throw new Error("Not a directory: "+t);for(var r=0,e=this.getDirectoryList(t);r<e.length;r++){var s=e[r];if(this.isDirectory(t+this.dirSep()+s)){if(!this.deleteDirectory(t+this.dirSep()+s))return!1}else if(!this.deleteFile(t+this.dirSep()+s))return!1}if(!i)return!0;try{return this.fs.rmdirSync(t),!0}catch(t){return!1}},t.prototype.saveFile=function(t,i,r){void 0===i&&(i=""),void 0===r&&(r=!1);try{return r?this.fs.appendFileSync(t,i):this.fs.writeFileSync(t,i),!0}catch(t){return!1}},t.prototype.createTempFile=function(){},t.prototype.mergeFiles=function(t,i,r){void 0===r&&(r="");for(var e="",s=0;s<t.length;s++)e+=this.readFile(t[s]),s<t.length-1&&""!==r&&(e+=r);return this.saveFile(i,e)},t.prototype.getFileSize=function(t){if(!this.isFile(t))throw new Error("File not found - "+t);try{return this.fs.statSync(t).size}catch(t){throw new Error("Error reading file size")}},t.prototype.readFile=function(t){if(!this.isFile(t))throw new Error("File not found - "+t);return this.fs.readFileSync(t,"utf8")},t.prototype.readFileBuffered=function(){},t.prototype.copyFile=function(t,i){try{return this.fs.copyFileSync(t,i),!0}catch(t){return!1}},t.prototype.renameFile=function(t,i){if(!this.isFile(t)||this.isDirectory(i)||this.isFile(i))return!1;try{return this.fs.renameSync(t,i),!0}catch(t){return!1}},t.prototype.deleteFile=function(t){if(!this.isFile(t))return!1;try{return this.fs.unlinkSync(t),!0}catch(t){return!1}},t.prototype.deleteFiles=function(t){for(var i=!0,r=0;r<t.length;r++)this.deleteFile(t[r])||(i=!1);return i},t.prototype._generateUniqueNameAux=function(t,i,r,e,s){var o=[];return s?(""!==r&&o.push(r),o.push(String(t)),""!==i&&o.push(i)):(""!==i&&o.push(i),""!==r&&o.push(r),o.push(String(t))),o.join(e)},t}();exports.FilesManager=FilesManager;