"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var StringUtils_1=require("../utils/StringUtils"),ArrayUtils_1=require("../utils/ArrayUtils"),JavaPropertiesObject_1=require("../model/JavaPropertiesObject"),LocalizationManager=function(){function t(){this.missingKeyFormat="$exception",this.wildCardsFormat="{N}",this.isBundleMandatory=!1,this._initialized=!1,this._locales=[],this._languages=[],this._activeBundle="",this._activePath="",this._loadedData={},this._filesManager=null,this._httpManager=null}return t.prototype.isInitialized=function(){return this._initialized},t.prototype.isLocaleLoaded=function(t){return this._locales.indexOf(t)>=0},t.prototype.isLanguageLoaded=function(t){if(2!==t.length)throw new Error("language must be a valid 2 digit value");return this._languages.indexOf(t)>=0},t.prototype.initialize=function(t,i,e,r,a){var o=this;void 0===r&&(r=null),void 0===a&&(a=null),t?this._httpManager=t:this._filesManager=t,this._locales=[],this._languages=[],this._activeBundle="",this._activePath="",this._loadedData={},this._loadData(i,e,function(t){o._initialized=!0,null!==r&&r(t)},a)},t.prototype.loadLocales=function(t,i,e){if(void 0===i&&(i=null),void 0===e&&(e=null),!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before loading more locales");for(var r=[],a=0,o=Object.keys(this._loadedData);a<o.length;a++){for(var n=o[a],l=[],s=0,d=Object.keys(this._loadedData[n]);s<d.length;s++){var h=d[s];l=l.concat(Object.keys(this._loadedData[n][h]))}r.push({path:n,bundles:ArrayUtils_1.ArrayUtils.removeDuplicateElements(l)})}this._loadData(t,r,i,e)},t.prototype.loadBundles=function(t,i,e,r){if(void 0===e&&(e=null),void 0===r&&(r=null),!ArrayUtils_1.ArrayUtils.isArray(i)||0===i.length)throw new Error("no bundles specified for path: "+t);if(!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before loading more bundles");this._loadData(this._locales,[{path:t,bundles:i}],e,r)},t.prototype._loadData=function(t,i,e,r){if(void 0===e&&(e=null),void 0===r&&(r=null),!ArrayUtils_1.ArrayUtils.isArray(t)||t.length<=0)throw new Error("no locales defined");if(!ArrayUtils_1.ArrayUtils.isArray(i)||i.length<=0)throw new Error("bundles must be an array of objects");for(var a=[],o=[],n=0,l=i;n<l.length;n++)for(var s=l[n],d=0,h=s.bundles;d<h.length;d++)for(var u=h[d],c=0,g=t;c<g.length;c++){var _=g[c];o.push({locale:_,bundle:u,path:s.path}),a.push(StringUtils_1.StringUtils.replace(s.path,["$locale","$bundle"],[_,u]))}this._locales=this._locales.concat(t),null!==this._filesManager||this._loadDataFromUrls(a,o,e,r)},t.prototype._loadDataFromUrls=function(t,i,e,r){var a=this;void 0===e&&(e=null),void 0===r&&(r=null),this._locales=ArrayUtils_1.ArrayUtils.removeDuplicateElements(this._locales),this._languages=this._locales.map(function(t){return t.substr(0,2)});var o=function(t){void 0===t&&(t=[]),i.length>0&&(a._activeBundle=i[i.length-1].bundle,a._activePath=i[i.length-1].path),null!==e&&e(t)};t.length<=0?o():this._httpManager.execute(t,function(e,r){for(var n=[],l=0;l<e.length;l++)if(e[l].isError)n.push({path:e[l].url,errorMsg:e[l].errorMsg,errorCode:e[l].errorCode});else{var s=i[l].locale,d=i[l].bundle,h=i[l].path,u=StringUtils_1.StringUtils.getPathExtension(t[l]);a._loadedData.hasOwnProperty(h)||(a._loadedData[h]={}),a._loadedData[h].hasOwnProperty(s)||(a._loadedData[h][s]={}),a._loadedData[h][s][d]="json"===u?a.parseJson(e[l].response):a.parseProperties(e[l].response)}o(n)},function(t,i){null!==r&&r(t,i)})},t.prototype.locales=function(){return this._locales},t.prototype.languages=function(){return this._languages},t.prototype.activeBundle=function(){return this._activeBundle},t.prototype.primaryLocale=function(){if(!this._initialized)throw new Error("LocalizationManager not initialized");return this._locales[0]},t.prototype.primaryLanguage=function(){if(!this._initialized)throw new Error("LocalizationManager not initialized");return this._languages[0]},t.prototype.setActiveBundle=function(t){for(var i=0,e=Object.keys(this._loadedData);i<e.length;i++)for(var r=e[i],a=0,o=Object.keys(this._loadedData[r]);a<o.length;a++){var n=o[a];if(Object.keys(this._loadedData[r][n]).indexOf(t)>=0)return this._activeBundle=t,void(this._activePath=r)}throw new Error(t+" bundle not loaded")},t.prototype.setPrimaryLocale=function(t){if(!StringUtils_1.StringUtils.isString(t))throw new Error("Invalid locale value");if(!this.isLocaleLoaded(t))throw new Error(t+" not loaded");for(var i=[t],e=0,r=this._locales;e<r.length;e++){var a=r[e];a!==t&&i.push(a)}this._locales=i,this._languages=this._locales.map(function(t){return t.substr(0,2)})},t.prototype.setPrimaryLanguage=function(t){for(var i=0,e=this._locales;i<e.length;i++){var r=e[i];if(r.substr(0,2)===t)return this.setPrimaryLocale(r)}throw new Error(t+" not loaded")},t.prototype.setLocalesOrder=function(t){if(!ArrayUtils_1.ArrayUtils.isArray(t))throw new Error("locales must be an array");if(t.length!==this._locales.length)throw new Error("locales must contain all the currently loaded locales");for(var i=0,e=t;i<e.length;i++){var r=e[i];if(!this.isLocaleLoaded(r))throw new Error(r+" not loaded")}this._locales=t,this._languages=this._locales.map(function(t){return t.substr(0,2)})},t.prototype.get=function(t,i,e,r){if(void 0===i&&(i=""),void 0===e&&(e=""),void 0===r&&(r=[]),!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before requesting translated texts");if(""===e&&(e=this._activePath),""===i){if(this.isBundleMandatory)throw new Error("bundle is mandatory for key "+t);i=this._activeBundle}if(-1===Object.keys(this._loadedData).indexOf(e))throw new Error("Path <"+e+"> not loaded");for(var a=0,o=this._locales;a<o.length;a++){var n=o[a];if(Object.keys(this._loadedData[e]).indexOf(n)>=0){if(-1===Object.keys(this._loadedData[e][n]).indexOf(i))throw new Error("Bundle <"+i+"> not loaded");if(Object.keys(this._loadedData[e][n][i]).indexOf(t)>=0){this._activeBundle=i,this._activePath=e;for(var l=this._loadedData[e][n][i][t],s=StringUtils_1.StringUtils.isString(r)?[String(r)]:r,d=0;d<s.length;d++)l=StringUtils_1.StringUtils.replace(l,StringUtils_1.StringUtils.replace(this.wildCardsFormat,"N",String(d)),s[d]);return l}}}if(this.missingKeyFormat.indexOf("$exception")>=0)throw new Error("key <"+t+"> not found on "+i+" - "+e);return this.missingKeyFormat.replace("$key",t)},t.prototype.getStartCase=function(t,i,e,r){return void 0===i&&(i=""),void 0===e&&(e=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,i,e,r),StringUtils_1.StringUtils.FORMAT_START_CASE)},t.prototype.getAllUpperCase=function(t,i,e,r){return void 0===i&&(i=""),void 0===e&&(e=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,i,e,r),StringUtils_1.StringUtils.FORMAT_ALL_UPPER_CASE)},t.prototype.getAllLowerCase=function(t,i,e,r){return void 0===i&&(i=""),void 0===e&&(e=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,i,e,r),StringUtils_1.StringUtils.FORMAT_ALL_LOWER_CASE)},t.prototype.getFirstUpperRestLower=function(t,i,e,r){return void 0===i&&(i=""),void 0===e&&(e=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,i,e,r),StringUtils_1.StringUtils.FORMAT_FIRST_UPPER_REST_LOWER)},t.prototype.parseJson=function(t){return JSON.parse(t)},t.prototype.parseProperties=function(t){for(var i={},e=new JavaPropertiesObject_1.JavaPropertiesObject(t),r=0,a=e.getKeys();r<a.length;r++){var o=a[r];i[o]=e.get(o)}return i},t}();exports.LocalizationManager=LocalizationManager;